#-------------------------------------
#Lecture de la table
cat("Lecture de la table brute","\n")
t=read.table(paste(dossierData,"/",dataName,".csv",sep=""),header=TRUE,sep=";")
t$DateNaissance=as.Date(t$DateNaissance,"%d/%m/%Y")
t$DateEntree=as.Date(t$DateEntree,"%d/%m/%Y")
t$DateSortie=as.Date(t$DateSortie,"%d/%m/%Y")
#-------------------------------------
#Slection des enregistrements dans la priode d'observation
cat("Slection des enregistrements","\n")
sDateDebutObservation="01/01/2011"
sDateFinObservation="31/12/2014"
DateDebutObservation=as.Date(sDateDebutObservation,"%d/%m/%Y")
DateFinObservation=as.Date(sDateFinObservation,"%d/%m/%Y")
t$DateEntree=pmax(t$DateEntree,DateDebutObservation)
t=subset(t,(t$DateEntree<=DateFinObservation))
#Suppression des enregistrements avec une date d'entre antrieure  la naissance
t=subset(t,(t$DateNaissance<=t$DateEntree))
#-------------------------------------
#Calcul des indicatrice de censure et de non censure
t$non_censure[t$Statut=="sinistr"]=1
t$non_censure[!(t$Statut=="sinistr")]=0
#Les individus sinistrs aprs la date de fin d'observation sont censurs  la date de fin d'observation
t$non_censure[(t$Statut=="sinistr")&(t$DateSortie>DateFinObservation)]=0
t$Statut[(t$Statut=="sinistr")&(t$DateSortie>DateFinObservation)]="autre"
t$DateSortie=pmin(t$DateSortie,DateFinObservation)
#-------------------------------------
#Calcul des ges
t$AgeEntreeJours=as.double(as.numeric(difftime(t$DateEntree,t$DateNaissance,"","days")))
t$AgeSortieJours=as.double(as.numeric(difftime(t$DateSortie,t$DateNaissance,"","days")))
t$AgeSortieJours[is.na(t$AgeSortieJours)==1]=DateFinObservation-t$DateNaissance[is.na(t$AgeSortieJours)==1]
t$AgeEntree=t$AgeEntreeJours/nbJoursAnnee
t$AgeSortie=t$AgeSortieJours/nbJoursAnnee
#-------------------------------------
#Suppression des ges aberrants
t_old=nrow(t)
t=subset(t,(t$AgeEntree>0))
cat(paste("Nombre de lignes aprs suppression des lignes pour lesquelles ge d'entre<=0 : ",nrow(t)," - ",t_old-nrow(t)," lignes limines"),"\n")
t_old=nrow(t)
t=subset(t,(t$AgeEntree<100))
cat(paste("Nombre de lignes aprs suppression des lignes pour lesquelles ge d'entre>=100 : ",nrow(t)," - ",t_old-nrow(t)," lignes limines"),"\n")
t_old=nrow(t)
t=subset(t,(t$AgeSortie>0))
cat(paste("Nombre de lignes aprs suppression des lignes pour lesquelles ge de sortie<=0 : ",nrow(t)," - ",t_old-nrow(t)," lignes limines"),"\n")
t_old=nrow(t)
t=subset(t,((t$AgeSortie-t$AgeEntree)>0))
cat(paste("Nombre de lignes aprs suppression des lignes pour lesquelles ge de sortie<=ge d'entre : ",nrow(t)," - ",t_old-nrow(t)," lignes limines"),"\n")
#-------------------------------------
#Construction des tableaux de donnes H et F
t$Sexe=as.factor(t$Sexe)
t_h=subset(t,(t$Sexe=="M"))
t_f=subset(t,(t$Sexe=="F"))

cat(paste("Proportion d'hommes (sex-ratio) : ",nrow(t_h)/nrow(t)),"\n")

#-------------------------------------
#Dcompte des dcs par ge
decesVentilesH=ventileDeces(t_h,sDateDebutObservation,sDateFinObservation)
decesVentilesF=ventileDeces(t_f,sDateDebutObservation,sDateFinObservation)
#Dcompte des expositions par ge
expoVentilesH=ventileExposition(t_h,sDateDebutObservation,sDateFinObservation)
expoVentilesF=ventileExposition(t_f,sDateDebutObservation,sDateFinObservation)

#-------------------------------------
#Mise en forme et synthse
a=as.vector(1:121)-1
ageMoyenExpoH=format(colSums(a*expoVentilesH)/colSums(expoVentilesH),digits=1,nsmall=1)
ageMoyenExpoF=format(colSums(a*expoVentilesF)/colSums(expoVentilesF),digits=1,nsmall=1)
ageMoyenDecesH=format(colSums(a*decesVentilesH)/colSums(decesVentilesH),digits=1,nsmall=1)
ageMoyenDecesF=format(colSums(a*decesVentilesF)/colSums(decesVentilesF),digits=1,nsmall=1)
qH=format(100*colSums(decesVentilesH)/colSums(expoVentilesH),digits=5,nsmall=3)
qF=format(100*colSums(decesVentilesF)/colSums(expoVentilesF),digits=5,nsmall=3)
cat(paste("Priodes : ",toString(names(expoVentilesH))),"\n")
cat("----------------------","\n")
cat(paste("Ventilation de l'exposition - H : ",toString(as.integer(colSums(expoVentilesH)))),"\n")
cat(paste("Age moyen de l'exposition - H : ",toString(ageMoyenExpoH)),"\n")
cat(paste("Ventilation des dcs - H : ",toString(colSums(decesVentilesH))),"\n")
cat(paste("Age moyen au dcs - H : ",toString(ageMoyenDecesH)),"\n")
cat(paste("Taux de dcs bruts (en %) - H : ",toString(qH)),"\n")
cat("----------------------","\n")
cat(paste("Ventilation de l'exposition - F : ",toString(as.integer(colSums(expoVentilesF)))),"\n")
cat(paste("Age moyen de l'exposition - F : ",toString(ageMoyenExpoF)),"\n")
cat(paste("Ventilation des dcs - F : ",toString(colSums(decesVentilesF))),"\n")
cat(paste("Age moyen au dcs - F : ",toString(ageMoyenDecesF)),"\n")
cat(paste("Taux de dcs bruts (en %) - F : ",toString(qF)),"\n")

#-------------------------------------
#Graphiques

sauveFigure()

par(mfrow=c(1,2))

plot(rowSums(expoVentilesH),type="l",xlab="Age",ylab="Exposition")
lines(rowSums(expoVentilesF),col="red")
title("Exposition par ges")
legend("topleft",legend = c("Hommes","Femmes"),col = c("black","red"), pch = 15, bty = "n", pt.cex = 1, cex = 0.8, horiz = F, inset = c(0.1, 0.1))

plot(rowSums(decesVentilesH),type="l",xlab="Age",ylab="Nombre de dcs")
lines(rowSums(decesVentilesF),col="red")
title("Dcs par ges")
legend("topleft",legend = c("Hommes","Femmes"),col = c("black","red"), pch = 15, bty = "n", pt.cex = 1, cex = 0.8, horiz = F, inset = c(0.1, 0.1))

dev.off()

#-------------------------------------
#Sauvegarde des rsultats
write.table(expoVentilesH,paste(dossierResultats,"/expoVentilesH.csv",sep=""),sep=";",row.names=FALSE, dec=",")
write.table(expoVentilesF,paste(dossierResultats,"/expoVentilesF.csv",sep=""),sep=";",row.names=FALSE, dec=",")
write.table(decesVentilesH,paste(dossierResultats,"/decesventilesH.csv",sep=""),sep=";",row.names=FALSE, dec=",")
write.table(decesVentilesF,paste(dossierResultats,"/decesventilesF.csv",sep=""),sep=";",row.names=FALSE, dec=",")