#-------------------------------------
#Comparaison de prdictions et de ralisations

tableEXP_h=paste(dossierTables,"/LxAjuste_h.csv",sep="")
tableEXP_f=paste(dossierTables,"/LxAjuste_f.csv",sep="")

tm_h=LectureTM(tableEXP_h)
tm_f=LectureTM(tableEXP_f)

plageAges=(20:70)

anneeDebut=as.integer(format(DateDebutObservation,"%Y"))
anneeFin=as.integer(format(DateFinObservation,"%Y"))
nbAnnees=anneeFin-anneeDebut+1

D=matrix(nrow=2,ncol=anneeFin-anneeDebut+1)
E=matrix(nrow=2,ncol=anneeFin-anneeDebut+1)

afficheComparaison=function(tm,c,annee){
#Graphe de comparaison des prdictions et des ralisations
  max95=c$decesPredits+1.96*sqrt((1-tm$Qx)*c$decesPredits)
  min95=c$decesPredits-1.96*sqrt((1-tm$Qx)*c$decesPredits)
  yMax=max(c$decesPredits[plageAges+1],c$decesObserves[plageAges+1],max95[plageAges+1])
  qxMoyen=sum(c$decesPredits[plageAges+1])/sum(c$effectifDebut[plageAges+1])
  up95=sum(c$decesPredits[plageAges+1])+1.96*(sum(c$effectifDebut[plageAges+1])*qxMoyen*(1-qxMoyen))^.5
  err=(up95-sum(c$decesPredits[plageAges+1]))/sum(c$decesPredits[plageAges+1])

  #x11()
  plot(x=plageAges,y=c$decesObserves[plageAges+1],ylim=c(0,yMax),xlab="Age",ylab="Nombre de dcs")
  lines(x=plageAges,y=c$decesPredits[plageAges+1],type="l",col="red")
  lines(x=plageAges,y=max95[plageAges+1],type="l",col="green")
  lines(x=plageAges,y=min95[plageAges+1],type="l",col="green")
  legend("topleft", legend = c("Observations","Loi ajuste","IC95"), col = c("black","red","green"), pch = 15, bty = "n", pt.cex = 2, cex = 0.8, horiz = TRUE, inset = c(0.1, 0.1))
  ratio=sum(c$decesObserves[plageAges+1])/sum(c$decesPredits[plageAges+1])
  txt1=paste("Ratio global observations / prdictions : ",format(100*ratio,digits=3)," %",sep="")
  txt2=paste("Incertitude : ",format(100*err,digit=2,nsmall=2)," %",sep="")
  subTxt=paste(txt1," - ",txt2,sep="")
  mainTxt=paste("Prdictions / Ralisations pour l'anne ",format(annee),sep="")
  title(main=mainTxt,sub=subTxt)  
  }

comparaisonH=matrix(nrow=length(plageAges),ncol=nbAnnees)
comparaisonF=matrix(nrow=length(plageAges),ncol=nbAnnees)
dates=seq(from=DateDebutObservation,to=DateFinObservation,by="year")
D=matrix(nrow=2,ncol=nbAnnees)
E=matrix(nrow=2,ncol=nbAnnees)
plageObservation=format(dates,"%Y")


#Hommes
sauveFigure()
par(mfrow=c(2,2))
for (i in 0:(nbAnnees-1)){
  c=compareDeces(t_h,tableEXP_h,dates[i+1],F)
  comparaisonH[,i+1]=c$decesPredits[plageAges+1]/c$decesObserves[plageAges+1]
  D[1,i+1]=sum(c$decesObserves[plageAges+1])
  E[1,i+1]=sum(c$decesPredits[plageAges+1])
  afficheComparaison(tm_h,c,anneeDebut+i)
  }
dev.off()

#Femmes
sauveFigure()
par(mfrow=c(2,2))
for (i in 0:(nbAnnees-1)){
  c=compareDeces(t_f,tableEXP_f,dates[i+1],F)
  comparaisonF[,i+1]=c$decesPredits[plageAges+1]/c$decesObserves[plageAges+1]
  D[2,i+1]=sum(c$decesObserves[plageAges+1])
  E[2,i+1]=sum(c$decesPredits[plageAges+1])
  afficheComparaison(tm_f,c,anneeDebut+i)
  }
dev.off()
#----------------------------------------------------------
#Comparaison de valeurs modlises et de ralisations
compareModele=function(tableEXP,expoVentiles,decesVentiles){

  tmEXP=LectureTM(tableEXP)
  qAjuste=tmEXP$Qx
  decesTheoriques=rowSums(expoVentiles)*qAjuste

  qxMoyen=decesTheoriques/rowSums(expoVentiles)
  decesTheoriques_up95=decesTheoriques+1.96*(rowSums(expoVentiles)*qxMoyen*(1-qxMoyen))^.5
  decesTheoriques_up95[is.na(decesTheoriques_up95)]=0
  decesTheoriques_dn95=pmax(0,decesTheoriques-1.96*(rowSums(expoVentiles)*qxMoyen*(1-qxMoyen))^.5)

  qGlobal=sum(decesTheoriques[plageAges+1])/sum(rowSums(expoVentiles)[plageAges+1])
  up95=sum(decesTheoriques[plageAges+1])+1.96*(sum(rowSums(expoVentiles)[plageAges+1])*qGlobal*(1-qGlobal))^.5
  dn95=sum(decesTheoriques[plageAges+1])-1.96*(sum(rowSums(expoVentiles)[plageAges+1])*qGlobal*(1-qGlobal))^.5
  err=(sum(decesTheoriques[plageAges+1])-dn95)/sum(decesTheoriques[plageAges+1])
  ratio=sum(decesVentiles[plageAges+1,])/sum(decesTheoriques[plageAges+1])
  txt1=paste("Ratio observations / modle : ",format(100*ratio,digits=3)," %",sep="")
  txt2=paste("Incertitude d'chantillonnage pour les dcs : ",format(100*err,digit=2,nsmall=2)," %",sep="")
  subTxt=paste(txt1," - ",txt2,sep="")

  #Reprsentations graphiques
  sauveFigure()
  plot(plageAges,decesTheoriques_up95[plageAges+1],type="l",col="green",xlab="Age",ylab="Dcs",ylim=c(0,max(decesTheoriques_up95[plageAges+1],rowSums(decesVentiles)[plageAges+1])))
  lines(plageAges,decesTheoriques[plageAges+1],col="red")
  lines(plageAges,decesTheoriques_dn95[plageAges+1],col="green")
  lines(plageAges,rowSums(decesVentiles)[plageAges+1],lty="dotted")
  title(main=tableEXP, sub=subTxt)
  legend("topright",legend=c("Modle","Observations","IC 95%"),col=c("red","black","green"), pch = 15, bty = "n", pt.cex = 1, cex = 0.8, horiz=F, inset = c(0.1, 0.1))
  dev.off()
  }

#NB : on ne conserve que les 3 dernires annes de la priode d'observation pour la comparaison

compareModele(tableEXP_h,expoVentilesH,decesVentilesH)
compareModele(tableEXP_f,expoVentilesF,decesVentilesF)
#----------------------------------------------------------
SMR=function(D,E){

  res=list()

  res$smr=D/E
  res$dn95=D/E*(1-1/(9*D)-1.96/(3*sqrt(D)))^3
  res$up95=(D+1)/E*(1-1/(9*(D+1))+1.96/(3*sqrt(D+1)))^3
  
  return(res)

  }

#----------------------------------------------------------
SMR_H=SMR(D[1,],E[1,])
SMR_F=SMR(D[2,],E[2,])
ymax=max(SMR_H$up95,SMR_F$up95)
ymin=min(SMR_H$dn95,SMR_F$dn95)
sauveFigure()
plot(plageObservation,SMR_H$smr,type="l",xlab="Anne",ylab="SMR",ylim=c(ymin,ymax))
lines(plageObservation,SMR_F$smr,col="red")
lines(plageObservation,SMR_H$up95,col="black",lty="dotted")
lines(plageObservation,SMR_H$dn95,col="black",lty="dotted")
lines(plageObservation,SMR_F$up95,col="red",lty="dotted")
lines(plageObservation,SMR_F$dn95,col="red",lty="dotted")
abline(h=1,lty=2,col="green")
mainTxt="SMR par anne"
title(main=mainTxt)
legend("topleft",legend = c("Hommes","Femmes"),col = c("black","red"), pch = 15, bty = "n", pt.cex = 1, cex = 0.8, horiz = F, inset = c(0.1, 0.1))
dev.off()
  