#----------------------------------------------------------
# Modles Aalen et Cox

#----------------------------------------------------------
#Modle de Cox
t_ajust$Sexe = relevel(t_ajust$Sexe,sexeH)
Cox=coxph(Surv(AgeEntree,AgeSortie,non_censure,type="counting")~Sexe,data=t_ajust)
print(summary(Cox))
print(cox.zph(Cox))

wCox = survfit(Cox,type="kaplan-meier")
qxCox=getQx(wCox,xMin,xMax+1)
qxCoxF=1-(1-qxCox)^exp(Cox$coefficient["SexeF"])

#Utilisation du modle d'Aalen
cat("Analyse de l'htrognit avec Aalen","\n")

aalen = aalen(Surv(AgeEntree,AgeSortie,non_censure,"counting")~Sexe,data=t_ajust) 
print(summary(aalen))

aalen$surv=exp(-aalen$cum[,"(Intercept)"])
aalen$time=aalen$cum[,"time"]
qxAalen=getQx(aalen,xMin,xMax+1)

aalenF=aalen
aalenF$surv=exp(-aalen$cum[,"(Intercept)"]-aalen$cum[,"SexeF"])
aalenF$time=aalen$cum[,"time"]
qxAalenF=getQx(aalenF,xMin,xMax+1)

sauveFigure()
plot(xPlage,qxCox,type="l",col="red",xlab="Age",ylab="qx")
lines(xPlage,qxAalen,col="blue")
lines(xPlage,qxCoxF,lty="dotted",col="red")
lines(xPlage,qxAalenF,lty="dotted",col="blue")
legend("topleft",legend = c("Cox","Aalen"),col = c("red","blue"), pch = 15, bty = "n", pt.cex = 1, cex = 0.8, horiz = F, inset = c(0.1, 0.1))
title(main="Comparaison des modles de Cox et Aalen",)
dev.off()

sauveFigure()
par(mfrow=c(2,2),oma=c(0,0,2,0))
plot(aalen)
title(main="Coefficients cumuls du modle d'Aalen",outer=T)
dev.off()


